/* Petit programme de servitude destié à vérifier une carte Arduino NANO.
   
   >>>>>>>>>> Version du 22 Juin 2020.
   
   UTILISATION DU PROGRAMME :
   ==========================
   Les 14 sorties binaires clignotent à une cadence d'environ 0,8S. Pour pouvoir s'assurer que deux
   broches voisines ne sont pas en contact intempestif, les sorties paires génères des impulsions lumineuses
   très courtes, alors que les sorties impaires s'illuminent durant 0,21 seconde.
   Les broches d'entrées analogiques programmées en sorties A0, A1, A2 et A3 fonctionnent de la même façon.
   Pour vérifier les deux entrées Analogiques A6 et A7 qui ne peuvent pas fonctionner en sorties, elles
   "recopient" leur état respectivement su A4 pou l'entrée A6 et sur A5 pour l'entrée A7.
   Pour tester ces deux entrées, il suffit de relier le témoin logique à LED soit à GND, soit au +5Vcc. La
   sortie associée sera alors éteinte ou allumée. (À la temporisation près.)
                        
 Branchements à effectuer : Strictement rien mis à part un témoin logique constitué d'une LED dont la cathode
 -------------------------- va sur GND, l'anode sur une résistance de 1Kohm. L'autre extrémité de la
                            résistance sert de pointe de touche pour vérifier les diverses sorties.

                                  PGM                 RAM dynamique
Programme complet :          1402 Octets (4%)       20 Octets (0%))  */

//----------------------- Déclaration des variables -------------------------
byte Sortie;
int Etat_entree;
int Delai_voulu = 400; // Durée en mS éventuellement corrigé de la fréquence XTAL.
unsigned long Temps_Ecoule_depuis_RESET = 0;
//======================================================================================

void setup() {
  for (byte Sortie = 0; Sortie < 18; Sortie++) {
       pinMode(Sortie, OUTPUT); }} //digitalWrite(Sortie, LOW);}}

void loop() {
  //================= Chronométrage pour le délai écoulé ================
  if (millis() - Temps_Ecoule_depuis_RESET > Delai_voulu)  {
     Temps_Ecoule_depuis_RESET = millis();
     //----------------- Actions à traiter pour chaque délai écoulé. -----------------
     for (Sortie = 0; Sortie < 18; Sortie++) digitalWrite(Sortie, HIGH);
     delay(10);
     for (Sortie = 0; Sortie < 17; Sortie = Sortie + 2) digitalWrite(Sortie, LOW);
     delay(200);
     for (Sortie = 1; Sortie < 18; Sortie = Sortie + 2) digitalWrite(Sortie, LOW);
     if (analogRead(20) > 512) Etat_entree = true; else Etat_entree = false;
     digitalWrite(18, Etat_entree);
     if (analogRead(21) > 512) Etat_entree = true; else Etat_entree = false;
     digitalWrite(19, Etat_entree);}}

