/* Programme minimal pour tester le lecteur de carte.
   Ne fait que vérifier la présence d'une carte SD dans le lecteur.
   Si problème affiche un texte d'état.
   Si OK se contente d'afficher un grand cadre vide sur OLED.

Branchements à effectuer :
--------------------------
 A4 : SDA OLED.
 A5 : SCL OLED.
 D10 : CS   
 D11 : MOSI
 D12 : MISO
 D13 : SCK
                                                                    PGM               RAM dynamique
Vérification présence carte et texte d'erreur.              9750 Octets (31%)     300 Octets (14%)*/

//--------------------- Déclarations pour le matériel -----------------------
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)
#include "PetitFS.h"
FATFS fs;     /* File system object */
//----------------------- Déclaration des variables -------------------------
boolean Lecteur_OK;

void setup() {
  u8g.setFont(u8g_font_profont12); // Police de matrices de 6x10 pixels lettres MAJ/min comprises.
  pinMode(10, OUTPUT); pinMode(11,INPUT); pinMode(12,INPUT); pinMode(13,INPUT);
  Teste_la_presence_carte_SD();}

void loop() {} // La boucle de base ne fait rien.

void Encadrement() {u8g.drawFrame(0,0,128,64);};

void Teste_la_presence_carte_SD() {
  Lecteur_OK = true; if (pf_mount(&fs))Lecteur_OK = false;
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  //------------------------------------------------------------------
  if (!Lecteur_OK) {u8g.setPrintPos(15, 40); u8g.print("Pb sur lecteur SD.");}
  else Encadrement();}
  //--------------------------------------------------------------
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.
