/* Programme pour lister le contenu "valide" de la carte SD sur OLED.
   Si problème de lecture un texte d'erreur est généré.
   ("Valide" signifie les fichiers "Img0.gco" à "Img9.gco")

Branchements à effectuer :
--------------------------
 A4 : SDA OLED.
 A5 : SCL OLED.
 D10 : CS   
 D11 : MOSI
 D12 : MISO
 D13 : SCK
                                                                    PGM               RAM dynamique
Intégration du listage de la carte sur OLED.                11348 Octets (36%)     342 Octets (16%) */
//--------------------- Déclarations pour le matériel -----------------------

#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)
#include "PetitFS.h"
FATFS fs;     /* File system object */
//----------------------- Déclaration des variables -------------------------
boolean Lecteur_OK;
boolean Existe[10];
char Indice[10] = {'0','1','2','3','4','5','6','7','8','9'};
char Nom_Fichier[9] = "IMGN.GCO";
//---------------------------------------------------------------------------

void setup() {
  u8g.setFont(u8g_font_profont12); // Police de matrices de 6x10 pixels lettres MAJ/min comprises.
  pinMode(10, OUTPUT); pinMode(11,INPUT); pinMode(12,INPUT); pinMode(13,INPUT);
  Liste_contenu_SD();}

void loop() {} // La boucle de base ne fait rien.

void Debut_Nom(byte X, byte Y, byte N) {u8g.setPrintPos(X, Y); u8g.print("Img"); u8g.print(N);}
void Affiche_OUI() {u8g.print(" oui");}
void Affiche_non() {u8g.print(" ---");}

void Liste_contenu_SD() {// Teste la présence carte et liste son "contenu images".
  byte X,Y;
  Lecteur_OK = true; if (pf_mount(&fs))Lecteur_OK = false;
  if(!Lecteur_OK){
     u8g.firstPage(); do {u8g.setPrintPos(15, 40); u8g.print("Pb sur lecteur SD.");} while(u8g.nextPage());}
  else {// Teste la présence éventuelle des dix fichiers possibles :
     for (byte I=0; I<10; I++) {Nom_Fichier[3] = Indice[I];
     Existe[I] = !pf_open(Nom_Fichier);
     // Afficher la liste :
     u8g.firstPage(); do {
        Y = 10; X = 0;
       for (byte I=0; I<10; I++) {
            if (I > 4) X = 66; if (I == 5) Y = 10;
            Debut_Nom(X,Y,I); if (Existe[I]) Affiche_OUI(); else Affiche_non();  Y = Y + 13;}}
    while(u8g.nextPage());}}}
  
  
  
  









