/* Programme indépendant pour simuler la gestion vectorielle des moteurs et testant
   automatiquement l'intégralité des combinaisons de coordonnées.

UTILISATION DU PROGRAMME :
==========================
Activer le moniteur de l'IDE et laisser le programme aller jusqu'à la dernière combinaison possible de
2250 x 2250. Si un cas particulier engendrait une "boucle infinie", l'arrêt du défilement
serait prématuré. Si la fin est 2250 x 2250 avec un nombre de simulations = 44258, c'est que la
procédure de vectorisation est fiable. (Il faut environ 1H50min environ à 115200 bauds.)

Branchements à effectuer : Aucun changement.
                                                                    PGM               RAM dynamique
Programme avec gestion de la ligne série du moniteur :         4046ctets (13%)     257 Octets (12%) */

//----------------------- Déclaration des variables -------------------------
boolean Fini;
int Compteur;
int Rapport; // Impérativement un int car peut aller jusqu'à 2250.
float Cumul, Decimale;
int DeltaX, DeltaY;
int NbPX, NbPY; // Nombres de pas réalisés. (Peuvent aller jusqu'à 2250.)

unsigned int Nb_de_tests_realises;

void setup() {Serial.begin(115200); Nb_de_tests_realises = 0;}

void loop() {
  for (int DeltaX = 0; DeltaX < 2251; DeltaX++)
      for (int DeltaY = 0; DeltaY < 2251; DeltaY++) {
           if (DeltaY <= DeltaX) {Traiter_les_mouvements_du_LASER(); Nb_de_tests_realises++;
           Serial.print("DeltaX = "); Serial.print(DeltaX);
           Serial.print("   DeltaY = "); Serial.println(DeltaY);}}
  Serial.println(); Serial.println();
  Serial.print("Nb total de verifications : "); Serial.println(Nb_de_tests_realises); 
  INFINI: goto INFINI;}

void Affiche_Position() {} // Ne rien faire.
     // Ci-dessus : Procédure conservée pour ne pas changer la structure du programme.

void Effectuer_un_mouvement_vectoriel() {
  // Attention ci-dessous cumul est utilisé pour un calcul préalable.
  Cumul = float(DeltaX) / float(DeltaY); // Toujours diviser le plus grand par le plus petit.
  Decimale = Cumul - ((int) Cumul); Rapport = Cumul - Decimale ;
  // Afficher les valeurs critiques calculées ci-avant :
  Cumul = 0.0; NbPX=0; NbPY=0; Fini = false;
  while (!Fini) {
    Compteur = 0;
    while (Compteur < Rapport) {
       if (NbPX < DeltaX) {NbPX++; Compteur++; Cumul = Cumul + Decimale; Affiche_Position();}
       else Compteur = Rapport;} // Forcer la sortie si NbPX = DeltaX.
    NbPY++; Affiche_Position();
    if (int(Cumul + 0.01) > 0) {
        if (NbPX < DeltaX) 
           {NbPX++; Cumul = abs(Cumul - 1); if (Cumul > 1) Cumul = abs(Cumul - 1); Affiche_Position();}}
    Fini = NbPX == DeltaX;}
  while (NbPY < DeltaY) {NbPY++; Affiche_Position();}}

void Traiter_les_mouvements_du_LASER() {
  NbPX = 0; NbPY = 0;
  if ((DeltaX > 0) || (DeltaY > 0)) {// Ne rien faire si les deux déplacements sont nuls.
     // Il est préférable de tester le cas où on retrouve sur plusieurs lignes des coordonnées
     // identiques. Ce n'est pas le cas pour les fichiers de LASER GRBL mais le fichier
     //  pourrait provenir d'un autre programme ou avoir été modifié manuellement.
     if (DeltaX == 0) {while (NbPY < DeltaY) {NbPY++; Affiche_Position();}}
     if (DeltaY == 0) {while (NbPX < DeltaX) {NbPX++; Affiche_Position();}}
     if ((DeltaX != 0) && (DeltaY != 0)) Effectuer_un_mouvement_vectoriel();}}



