/* Programme indépendant pour simuler la gestion des déplacements par coordonnées.
   Dérivé de P13, ce programme sert à mettre en place toutes les routines qui permettront de gérer
   les déplacements en coordonnées cartésiennes issues des programmes de type gco.
   Dans ce programme l'initialisation de l'ORIGINE MACHINE est invoquée dans les void setup();

   >>>> Pour faciliter l'interprétation des résultats, provisoirement Coef_poulie = 1.
   
   >>>> Commentaires sur ce programme en fin de listage.

UTILISATION DU PROGRAMME :
==========================
Saisir à l'invitation la valeur de la position à atteindre sur X comprise entre 0 et 225,0.
Saisir à la demande la position à atteindre sur X comprise entre 0 et 225,0. (Maximas sur la machine.)
>>>>> Attention, il n'y a aucun contrôle sur les valeurs proposées.
>>>>> Ne donner qu'une décimale après la virgule.
Ces coordonnées peuvent être strictement quelconques dans les plages définies.

Branchements à effectuer : Aucun changement.

>>>>>> Dans ce démonstrateur les variables telles que Compteur, Cumul, Decimale, Rapport sont déclarées
       en variables locales et passées par paramètres aux procédures concernées.

                                                                    PGM               RAM dynamique
Programme avec gestion de la ligne série du moniteur :           6792 (21%)          367 Octets (17%) */

#define TailleTexte 10 // Taille réservée pour LGR_MAX plus le délimiteur.

//------------------- Déclaration des constante du programme ----------------
// #define Coef_poulie 0.9804 // Correction du diamètre moyen de la poulie motrice. @@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Coef_poulie 1

//-------------- Déclaration des variables pour le dialogue série -----------
char TEXTE[TailleTexte]; // Place pour LGR_MAX caractères plus le délimiteur.
byte I = 0; // Pointeur dans la chaine TEXTE.
float ARGUMENT;
boolean Valeurs_correctes;
//----------------------- Déclaration des variables -------------------------
boolean DX_Positif, DY_Positif;
int Ancien_X, Ancien_Y; // Positions exprimées en dixièmes de mm. 
float Position_X, Position_Y;

void setup() {
  Serial.begin(115200);   I=0; // Au départ la chaine est vide.
  while(Serial.available() > 0) {Serial.read(); delay(5);}   // Purger entièrement le FIFO.
  Capture_Origine_Machine();}

void loop() {
  // ++++++++++++++++++++ Saisir les valeurs DeltaX et pour DeltaY ++++++++++++++++
  Serial.println(); Serial.print("Valeur X ?");
  while (I==0) Traiter_la_ligne_USB_du_Moniteur(); Position_X = ARGUMENT; I=0;
  Serial.print(" >>> "); Serial.println(Position_X,1);
  Serial.print("Valeur Y ?");
  while (I==0) Traiter_la_ligne_USB_du_Moniteur(); Position_Y = ARGUMENT; I=0;
  Serial.print(" >>> "); Serial.print(Position_Y,1);
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Effectuer_un_deplacement_gco();}

void Traiter_la_ligne_USB_du_Moniteur() {
  while((Serial.available() > 0) && (I < (TailleTexte-1))) // Si FIFO non vide lire les caractères.
       {TEXTE[I] = Serial.read(); I++; delay(5);} // Délai impératif.
  TEXTE[I] = '\0'; // Placer le délimiteur de fin de texte.
  // Purger entièrement le FIFO si plus de LGR_MAX caractères envoyés.
  ARGUMENT = atof(TEXTE);}

//=================================================================================================
void Capture_Origine_Machine() {// Il faudra éteindre le témoin bleu.
  Ancien_X = 0; Ancien_Y = 0;}
  
void Affiche_Position() {
  Serial.println(); Serial.print("Position X = "); Serial.print(Ancien_X);
  Serial.print("  Position Y = "); Serial.println(Ancien_Y);
  Serial.print("---------------------------------------");}

void Faire_un_pas_sur_X() {// Dans la procédure définitive il faudra tester les limites.
  // Ici on se contente de mettre à jour la position atteinte :
  if (DX_Positif) Ancien_X++; else Ancien_X--;}

void Faire_un_pas_sur_Y() {// Dans la procédure définitive il faudra tester les limites.
  // Ici on se contente de mettre à jour la position atteinte :
  if (DY_Positif) Ancien_Y++; else Ancien_Y--;}
  
void Effectuer_un_mouvement_vectoriel(int DeltaX, int DeltaY, boolean DX_sup_a_DY) {
  boolean Fini; int NbPX, NbPY; float Cumul, Decimale;
  int Compteur; int Rapport; // Impérativement un int car peut aller jusqu'à 2250.
  // Attention ci-dessous cumul est utilisé pour un calcul préalable du rapport décimal.
  if (DX_sup_a_DY) Cumul = float(DeltaX) / float(DeltaY); else Cumul = float(DeltaY) / float(DeltaX);
  Decimale = Cumul - ((int) Cumul); Rapport = Cumul - Decimale ;
  // Afficher les valeurs critiques calculées ci-avant :
  Serial.println(); Serial.print("DeltaX / DeltaY = "); Serial.println(Cumul,5);
  Serial.print("Rapport = "); Serial.println(Rapport);
  Serial.print("Decimale = "); Serial.print(Decimale,5);
  Cumul = 0.0; NbPX=0; NbPY=0; Fini = false;
  if (DX_sup_a_DY) {
      while (!Fini) {
        Compteur = 0;
        while (Compteur < Rapport) {
           if (NbPX < DeltaX) {Faire_un_pas_sur_X(); NbPX++; Compteur++; Cumul = Cumul + Decimale;}
           else Compteur = Rapport;} // Forcer la sortie si NbPX = DeltaX.
        Faire_un_pas_sur_Y(); NbPY++; 
        if (int(Cumul + 0.01) > 0) {// Donc Cumul vaut au moins 1.
        if (NbPX < DeltaX) 
           {Faire_un_pas_sur_X(); NbPX++; Cumul = abs(Cumul - 1); if (Cumul > 1) Cumul = abs(Cumul - 1);}}
        Fini = NbPX == DeltaX;}
      while (NbPY < DeltaY) {Faire_un_pas_sur_Y(); NbPY++;}}
  else {// Si DeltaY > DeltaX il faut inverser les rôles joués par X et par Y.
      while (!Fini) {// Si DeltaX inférieur à DeltaY il faux échanger les rôles de X et de Y.
        Compteur = 0;
        while (Compteur < Rapport) {
           if (NbPY < DeltaY) {Faire_un_pas_sur_Y(); NbPY++; Compteur++; Cumul = Cumul + Decimale;}
           else Compteur = Rapport;} // Forcer la sortie si NbPY = DeltaY.
        Faire_un_pas_sur_X(); NbPX++; 
        if (int(Cumul + 0.01) > 0) {// Donc Cumul vaut au moins 1.
        if (NbPY < DeltaY) 
           {Faire_un_pas_sur_Y(); NbPY++; Cumul = abs(Cumul - 1); if (Cumul > 1) Cumul = abs(Cumul - 1);}}
        Fini = NbPY == DeltaY;}
      while (NbPX < DeltaX) {Faire_un_pas_sur_X(); NbPX++;}}}

void Traiter_les_mouvements_du_LASER(int DeltaX, int DeltaY, boolean DX_sup_a_DY) {
  int NbPX = 0;   int NbPY = 0;
  if ((DeltaX > 0) || (DeltaY > 0)) {// Ne rien faire si les deux déplacements sont nuls.
  if (DeltaX == 0) while (NbPY < DeltaY) {Faire_un_pas_sur_Y(); NbPY++;}
  if (DeltaY == 0) while (NbPX < DeltaX) {Faire_un_pas_sur_X(); NbPX++;}
  if ((DeltaX != 0) && (DeltaY != 0)) Effectuer_un_mouvement_vectoriel(DeltaX, DeltaY, DX_sup_a_DY);}}

void Effectuer_un_deplacement_gco() {
  // Ancien_X et Ancien_Y sont mis à jour par les routines qui font faire un pas aux moteurs.
  boolean DX_sup_a_DY;
  int DeltaX, DeltaY; // grandeur du déplacement à effectuer.
  int X,Y; // Les coordonnées à atteindre exprimées en dixième de mm :
  X = int(Position_X * 10 * Coef_poulie); // Abscisse à atteindre en dixièmes de mm.
  Y = int(Position_Y * 10 * Coef_poulie); // Ordonnée à atteindre en dixièmes de mm.
  DX_Positif = (X >= Ancien_X); DY_Positif = (Y >= Ancien_Y); // Détermine les sens de déplacement.
  if (DX_Positif) DeltaX = X - Ancien_X; else DeltaX = Ancien_X - X;
  if (DY_Positif) DeltaY = Y - Ancien_Y; else DeltaY = Ancien_Y - Y;
  DX_sup_a_DY = (DeltaX >= DeltaY);
  Traiter_les_mouvements_du_LASER(DeltaX, DeltaY, DX_sup_a_DY); Affiche_Position();}

/* Commentaires sur ce programme relatif à la motorisation.
   ========================================================
   Évaluations initiales. (Évaluations car la machine n'étant pas encore assemblée il n'est pas
   possible de comparer les déplécements effectifs à ceux prévus dans les essais.) Le diamètre moyen de la
   poulie motrice est évalué à 13mm soit un périmètre de 40,8mm. Si on adopte le mode "direct" sur X
   et sur Y il faut 200 pas pour effectuer un tour. Le déplacement dans ce cas sera de :
   40,8 / 200 = 0.204mm qui sera assimilé à deux dixièmes de mm. 
   Précision de la machine : Elle sera de 0,5mm par "tir LASER" donc 5 pas par déplacements élémentaires.
   En vue de corriger les 2% on va utiliser un coefficient de correction égal à 0.98.
   Ce coefficient "Coef_poulie" pourra être ajusté lorsque la machine sera disponible. */
