/* Programme indépendant pour simuler la gestion complète des moteurs et testant
   automatiquement la globalité des combinaisons de coordonnées typiques.

NOTE : Il est évident que les procédures Teste_Secteur_1() à Teste_Secteur_4() pourraient se voir
       "compactées" en une seule, avec modification d'un ou deux paramètres en interne. Comme elles
       ne seront pas intégrées dans le programme définitif, optimiser n'est pas important. Par contre,
       avoir divisé le test en quatre zone autorise facilement des vérifications par secteurs
       angulaires si on le désire.

UTILISATION DU PROGRAMME :   (Voir les fiches dédiées pour les options possibles.)
==========================
Activer le moniteur de l'IDE et laisser le programme aller jusqu'à la dernière vérification.
Si la fin indique un nombre de simulations de 14938, c'est que les procédures de déplacement
peuvent être considérées comme fiables. (Il faut environ 8min affichages en option non validés.)

Branchements à effectuer : Aucun changement.
                                                                    PGM               RAM dynamique
Programme avec gestion de la ligne série du moniteur :         6966 octets (22%)     276 Octets (13%)
ATTENTION : les occupations mémoire indiquée ne sont vraies qui si aucune ligne d'affichages en
            options n'est validée en supprimant le // qui la force en "remarque ignorée".          */

#define TailleTexte 10 // Taille réservée pour LGR_MAX plus le délimiteur.

//------------------- Déclaration des constante du programme ----------------
#define Coef_poulie_X 1 // Valeur provisoire 1 pour faciliter l'interprétation des affichages.
#define Coef_poulie_Y 1 // Valeur provisoire 1 pour faciliter l'interprétation des affichages.

//----------------------- Déclaration des variables -------------------------
boolean DX_Positif, DY_Positif; //, DX_sup_a_DY;
int Ancien_X, Ancien_Y; // Positions exprimées en dixièmes de mm. 
float Position_X, Position_Y;

unsigned long Nb_de_tests_realises;

void setup() {Serial.begin(115200); Nb_de_tests_realises = 0;}

void loop() {
  Serial.println(); Serial.print("Debut de la simulation.");
  Teste_Secteur_1();
  Teste_Secteur_2();
  Teste_Secteur_3();
  Teste_Secteur_4();
  Teste_le_grand_disque_central();
  Teste_le_petit_disque_central();
  Teste_le_balayage_total_horizontal();
  Teste_le_balayage_total_vertical();
  Serial.println(); Serial.print("FIN de la simulation.");
  INFINI: goto INFINI;}

void Affiche_position() {return; //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  Serial.println(); Serial.print("X = "); Serial.print(Ancien_X);
  Serial.print("  Y = "); Serial.print(Ancien_Y);}

void Affiche_Nb_tests() {
  Serial.println(); Serial.print("Nb total de verifications : "); Serial.print(Nb_de_tests_realises);}

void Teste_Secteur_1() {
  float Ancienne_abscisse;
  Ancien_X = 112.5; Ancien_Y = 112.5; Position_X = 0;
  for (int I = 0; I < 2250; I++){
      Ancienne_abscisse = Position_X;
      // Déplacement virtuel du LASER en diagonale maximale :
      Position_X = 112.5; Position_Y = 112.5; Effectuer_un_deplacement_gco(); Affiche_position();
      // Déplace virtuel du le LASER en diagonale maximale :
      Position_X = Ancienne_abscisse; Position_X = Position_X + 0.1; Position_Y = 225.0;
      Effectuer_un_deplacement_gco(); Affiche_position();
      Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

void Teste_Secteur_2() {
  float Ancienne_ordonnee;  // Ci-dessous Position_Y 225.1 et non 225.0 pour avoir la première diagonale.
  Ancien_X = 112.5; Ancien_Y = 112.5; Position_Y = 225.1;
  for (int I = 0; I < 2250; I++){
      Ancienne_ordonnee = Position_Y;
      // Déplacement virtuel du LASER en diagonale maximale :
      Position_X = 112.5; Position_Y = 112.5; Effectuer_un_deplacement_gco(); Affiche_position();
      // Déplace virtuel du le LASER en diagonale maximale :
      Position_Y = Ancienne_ordonnee; Position_Y = Position_Y - 0.1; Position_X = 112.5;
      Effectuer_un_deplacement_gco(); Affiche_position();
      Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

void Teste_Secteur_3() {
  float Ancienne_abscisse;
  Ancien_X = 112.5; Ancien_Y = 112.5; Position_X = 225.0;
  for (int I = 0; I < 2250; I++){
      Ancienne_abscisse = Position_X;
      // Déplacement virtuel du LASER en diagonale maximale :
      Position_X = 112.5; Position_Y = 112.5; Effectuer_un_deplacement_gco(); Affiche_position();
      // Déplace virtuel du le LASER en diagonale maximale :
      Position_X = Ancienne_abscisse; Position_X = Position_X - 0.1; Position_Y = 0;
      Effectuer_un_deplacement_gco(); Affiche_position();
      Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

void Teste_Secteur_4() {
  float Ancienne_ordonnee;  // Ci-dessous Position_Y 225.1 et non 225.0 pour avoir la première diagonale.
  Ancien_X = 112.5; Ancien_Y = 112.5; Position_Y = 0;
  for (int I = 0; I < 2250; I++){
      Ancienne_ordonnee = Position_Y;
      // Déplacement virtuel du le LASER au centre du plateau :
      Position_X = 112.5; Position_Y = 112.5; Effectuer_un_deplacement_gco(); Affiche_position();
      // Déplacement virtuel du LASER en diagonale maximale :
      Position_Y = Ancienne_ordonnee; Position_Y = Position_Y + 0.1; Position_X = 0 ;
      Effectuer_un_deplacement_gco(); Affiche_position();
      Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

void Teste_le_grand_disque_central() {
  float SAVX, SAVY;
  float Angle = 359.5;
  for (int I=0; I < 720; I++) {
       Position_X = 112.5 + (112 * sin(radians(Angle)));
       Position_Y = 112.5 + (112 * cos(radians(Angle)));
       //Serial.println(); Serial.print("Angle = "); Serial.print(Angle,1);
       //Serial.print("   X = "); Serial.print(Position_X,1);
       //Serial.print("   Y = "); Serial.print(Position_Y,1);
       // Déplacement virtuel du le LASER au centre du plateau :
       SAVX = Position_X; SAVY = Position_Y;
       Position_X = 112.5; Position_Y = 112.5; Effectuer_un_deplacement_gco(); Affiche_position();
       // Déplace virtuel du le LASER sur le périmètre du disque à balayer :
       Position_X = SAVX; Position_Y = SAVY;
       Effectuer_un_deplacement_gco(); Affiche_position();
       Angle =  Angle - 0.5; Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

void Teste_le_petit_disque_central() {
  float SAVX, SAVY;
  float Angle = 359.5;
  for (int I=0; I < 720; I++) {
       Position_X = 112.5 + (1 * sin(radians(Angle)));
       Position_Y = 112.5 + (1 * cos(radians(Angle)));
       //Serial.println(); Serial.print("Angle = "); Serial.print(Angle,1);
       //Serial.print("   X = "); Serial.print(Position_X,1);
       //Serial.print("   Y = "); Serial.print(Position_Y,1);
       // Déplacement virtuel du le LASER au centre du plateau :
       SAVX = Position_X; SAVY = Position_Y;
       Position_X = 112.5; Position_Y = 112.5; Effectuer_un_deplacement_gco(); Affiche_position();
       // Déplace virtuel du le LASER sur le périmètre du disque à balayer :
       Position_X = SAVX; Position_Y = SAVY;
       Effectuer_un_deplacement_gco(); Affiche_position();
       Angle =  Angle - 0.5; Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

 void Teste_le_balayage_total_horizontal() {
   Ancien_X = 0; Ancien_Y = 225.0; Position_Y = 225.0;
   for (int I = 0; I < 2250; I++){
      // Déplacement virtuel du LASER à gauche :
      Position_X = 0; Effectuer_un_deplacement_gco(); Affiche_position();
      // Déplacement virtuel du LASER à droite :
      Position_X = 225.0; Effectuer_un_deplacement_gco(); Affiche_position();
      Position_Y = Position_Y - 0.1; Nb_de_tests_realises++;}
  Affiche_Nb_tests();}

 void Teste_le_balayage_total_vertical() {
   Ancien_X = 0; Ancien_Y = 225.0; Position_X = 225.0;
   for (int I = 0; I < 2250; I++){
      // Déplacement virtuel du LASER vers l'arrière de la machine :
      Position_Y = 0; Effectuer_un_deplacement_gco(); Affiche_position();
      // Déplacement virtuel du LASER vers l'avant de la machine :
      Position_Y = 225.0; Effectuer_un_deplacement_gco(); Affiche_position();
      Position_X = Position_X - 0.1; Nb_de_tests_realises++;}
  Affiche_Nb_tests();}
//=================================================================================================
void Capture_Origine_Machine() {// Il faudra éteindre le témoin bleu.
  Ancien_X = 0; Ancien_Y = 0;}

void Faire_un_pas_sur_X() {// Dans la procédure définitive il faudra tester les limites.
  // Ici on se contente de mettre à jour la position atteinte :
  if (DX_Positif) Ancien_X++; else Ancien_X--; }

void Faire_un_pas_sur_Y() {// Dans la procédure définitive il faudra tester les limites.
  // Ici on se contente de mettre à jour la position atteinte :
  if (DY_Positif) Ancien_Y++; else Ancien_Y--; }
  
void Effectuer_un_mouvement_vectoriel(int DeltaX, int DeltaY, boolean DX_sup_a_DY) {
  boolean Fini; int NbPX, NbPY; float Cumul, Decimale;
  int Compteur; int Rapport; // Impérativement un int car peut aller jusqu'à 2250.
  // Attention ci-dessous cumul est utilisé pour un calcul préalable du rapport décimal.
  if (DX_sup_a_DY) Cumul = float(DeltaX) / float(DeltaY); else Cumul = float(DeltaY) / float(DeltaX);
  Decimale = Cumul - ((int) Cumul); Rapport = Cumul - Decimale ;
  Cumul = 0.0; NbPX=0; NbPY=0; Fini = false;
  if (DX_sup_a_DY) {
      while (!Fini) {
        Compteur = 0;
        while (Compteur < Rapport) {
           if (NbPX < DeltaX) {Faire_un_pas_sur_X(); NbPX++; Compteur++; Cumul = Cumul + Decimale;}
           else Compteur = Rapport;} // Forcer la sortie si NbPX = DeltaX.
        Faire_un_pas_sur_Y(); NbPY++; 
        if (int(Cumul + 0.01) > 0) {// Donc Cumul vaut au moins 1.
        if (NbPX < DeltaX) 
           {Faire_un_pas_sur_X(); NbPX++; Cumul = abs(Cumul - 1); if (Cumul > 1) Cumul = abs(Cumul - 1);}}
        Fini = NbPX == DeltaX;}
      while (NbPY < DeltaY) {Faire_un_pas_sur_Y(); NbPY++;}}
  else {while (!Fini) {
        Compteur = 0;
        while (Compteur < Rapport) {
           if (NbPY < DeltaY) {Faire_un_pas_sur_Y(); NbPY++; Compteur++; Cumul = Cumul + Decimale;}
           else Compteur = Rapport;} // Forcer la sortie si NbPX = DeltaX.
        Faire_un_pas_sur_X(); NbPX++; 
        if (int(Cumul + 0.01) > 0) {// Donc Cumul vaut au moins 1.
        if (NbPY < DeltaY) 
           {Faire_un_pas_sur_Y(); NbPY++; Cumul = abs(Cumul - 1); if (Cumul > 1) Cumul = abs(Cumul - 1);}}
        Fini = NbPY == DeltaY;}
      while (NbPX < DeltaX) {Faire_un_pas_sur_X(); NbPX++;}}}

void Traiter_les_mouvements_du_LASER(int DeltaX, int DeltaY, boolean DX_sup_a_DY) {
  int NbPX = 0;   int NbPY = 0;
  if ((DeltaX > 0) || (DeltaY > 0)) {// Ne rien faire si les deux déplacements sont nuls.
  if (DeltaX == 0) while (NbPY < DeltaY) {Faire_un_pas_sur_Y(); NbPY++;}
  if (DeltaY == 0) while (NbPX < DeltaX) {Faire_un_pas_sur_X(); NbPX++;}
  if ((DeltaX != 0) && (DeltaY != 0)) Effectuer_un_mouvement_vectoriel(DeltaX, DeltaY, DX_sup_a_DY);}}

void Effectuer_un_deplacement_gco() {
  // Ancien_X et Ancien_Y sont mis à jour par les routines qui font faire un pas aux moteurs.
  boolean DX_sup_a_DY;
  int DeltaX, DeltaY; // grandeur du déplacement à effectuer.
  int X,Y; // Les coordonnées à atteindre exprimées en dixième de mm :
  X = int(Position_X * 10 * Coef_poulie_X); // Abscisse à atteindre en dixièmes de mm.
  Y = int(Position_Y * 10 * Coef_poulie_Y); // Ordonnée à atteindre en dixièmes de mm.
  DX_Positif = (X >= Ancien_X); DY_Positif = (Y >= Ancien_Y); // Détermine les sens de déplacement.
  if (DX_Positif) DeltaX = X - Ancien_X; else DeltaX = Ancien_X - X;
  if (DY_Positif) DeltaY = Y - Ancien_Y; else DeltaY = Ancien_Y - Y;
  DX_sup_a_DY = (DeltaX >= DeltaY);
  Traiter_les_mouvements_du_LASER(DeltaX, DeltaY, DX_sup_a_DY);}

/* Commentaires sur ce programme relatif à la motorisation.
   ========================================================
   Évaluations initiales. (Évaluations car la machine n'étant pas encore assemblée il n'est pas
   possible de comparer les déplécements effectifs à ceux prévus dans les essais.) Le diamètre moyen de la
   poulie motrice est évalué à 13mm soit un périmètre de 40,8mm. Si on adopte le mode "demi pas" sur X
   et sur Y il faut 400 pas pour effectuer un tour. Le déplacement dans ce cas sera de :
   40,8 / 400 = 0.102mm qui sera assimilé à un dixième de mm : Précision de la machine.
   En vue de corriger les 2% on va utiliser un coefficient de correction égal à 0,9804.
   Ce coefficient "Coef_poulie" pourra être ajusté lorsque la machine sera disponible. */

