/* Directement issu de P11 ce programme qui sert de préambule au développement de P16
   permet de mettre au point la gestion des deux origines sur X et Y.
   En particulier on mesure les tensions numérisées sur A6 et A7. Pour chacune on fait la moyenne entre
   les deux extrêmes et l'on ajuste la constante concernée en @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.
   Ces constantes seront réutilisées dans le programme d'exploitation.
   
   Détermination des seuils opérationnels :
   ----------------------------------------
   1) Pour chaque entrée, noter le plus grand X et le plus grand Y quand le Capteur est masqué,
   2) Pour chaque entrée, noter le petit grand X et le plus petit Y quand le Capteur est illuminé,
   3) Pour chaque entrée, le Seuil_Origine sera égal à la moyenne de ces deux valeurs.
   EXEMPLE : X illuminé maxi = 207, X caché mini=1021 > Seuil_Origine_X = (207 + 1021) / 2 = 614.

Branchements à effectuer :
--------------------------
 A6 : Capteur de butée sur X.
 A7 : Capteur de butée sur Y.
                                                                    PGM               RAM dynamique
Mise en place des mesures et des comparaisons.                8086 Octets (26%)     306 Octets (14%)   */

//--------------------- Déclarations pour le matériel -----------------------
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)
//------------- Définition des broches d'entrées analogiques ----------------
#define Capteur_Origine_X  20 // A6 pour lire le capteur sur butée X.
#define Capteur_Origine_Y  21 // A7 pour lire le capteur sur butée X.
//-------------- Définition des broches de sorties Binaires -----------------
//------------------------ Constantes du programme --------------------------
#define Seuil_Origine_X 614 // Tension moyenne entre Actif et neutre sur X. @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Seuil_Origine_Y 558 // Tension moyenne entre Actif et neutre sur Y. @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//----------------------- Déclaration des variables -------------------------
boolean X_actif, Y_actif;
int U_sur_X, U_sur_Y;

void setup() {u8g.setFont(u8g_font_profont12);}

void loop() {
  Mesurer_les_tensions_origines();
  X_actif = (U_sur_X > Seuil_Origine_X); Y_actif = (U_sur_Y > Seuil_Origine_Y);
  //--------------------------------------------------------------------------------
  u8g.firstPage(); do {
  u8g.setPrintPos(15, 15); u8g.print("U Origine X = "); u8g.print(U_sur_X);
  u8g.setPrintPos(15, 30); u8g.print("U Origine Y = ");  u8g.print(U_sur_Y);
  u8g.setPrintPos(15, 45); u8g.print("Origine X :  "); 
  if (X_actif) u8g.print("OUI"); else u8g.print("NON");
  u8g.setPrintPos(15, 60); u8g.print("Origine Y :  "); 
  if (Y_actif) u8g.print("OUI"); else u8g.print("NON");}
  while(u8g.nextPage());}

void Mesurer_U_Capteur(boolean Sur_X) {
  // Mesure avec 250 itérations pour l'intégration "d'antiparasitage".
  long Valeurs_lues;
  byte Compteur = 250;
  Valeurs_lues = 0;
  for (int I = 0; I < Compteur; I++) // Cumuler N mesures. 
      {if (Sur_X) Valeurs_lues = Valeurs_lues + analogRead(Capteur_Origine_X);
       else Valeurs_lues = Valeurs_lues + analogRead(Capteur_Origine_Y);}
  if (Sur_X) U_sur_X = int(Valeurs_lues / 250); else U_sur_Y = int(Valeurs_lues / 250);}
 
void Mesurer_les_tensions_origines() {
  Mesurer_U_Capteur(true); Mesurer_U_Capteur(false);}
  

