/* Directement issu de P17 ce programme n'en conserve que quelques procédures pour élaborer
   les diverses Pages-Ecran et les menus qui seront intégrés dans le programme d'exploitation.
   
   UTILISATION DU PROGRAMME :   Explorer les divers items pour vérifier le chaînage, les manipulations
   ==========================   de saisie et les présentations sur l'écran qui en résultent.
   >>>>>>>>>> L'entrée et la sortie de tous les menus se fait avec le BP du codeur rotatif.
   
   MENU de BASE :    Clavier : Seul le B.P. noir a un effet : Allumer ou éteindre l'écran.
   --------------    Codeur rotatif : Change d'item dans la liste affichée.
                     B.P. central du codeur incrémental : Valide l'item et passe au menu indexé.
                  
   MENU PYROGRAVER : B.P. n°1 : LASER en origine IMAGE si option préalablement armée avec B.P. n°3.
   ----------------- B.P. n°2 : Allumer ou éteindre l'écran.
                     B.P. n°3 : Inverse l'option "Affichage". Si valeur "OUI" arme le B.P. n°1.
                     B.P. n°4 : Active l'opération de PYROGRAVURE.
                     B.P. n°5 : Affiche les caractéristiques du fichier IMAGE.
                     Codeur rotatif : Change de fichier dans la liste affichée des images du contenu SD.
                     B.P. central du codeur incrémental : Retour au MENU de BASE.
 
   MENU FICHIER :    B.P. n°1 : Relecture de la carte SD. (Utile quand elle vient d'être changée.)
   --------------    B.P. n°2 : Allumer ou éteindre l'écran.
                     B.P. n°3 : Inverse l'option  Pas à pas.
                     B.P. n°4 : Déclenche l'Analyse Syntaxique.
                     B.P. n°5 : Affiche les caractéristiques du fichier IMAGE.
                     Codeur rotatif : Change de fichier dans la liste affichée des images du contenu SD.
                     B.P. central du codeur incrémental : Retour au MENU de BASE.
 
   Mode MANUEL :     L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
   -------------     Les B.P. rouges font déplacer en répétition.
                     Le B.P. noir : Activation du LASER qui ne s'allumera que durant les déplacements.
                     Codeur rotatif : Incrémente/Décrémente par 0,5mm la valeur des déplacements par B.P.
                     B.P. central du codeur incrémental : Retour au MENU de BASE.
                     Si LASER actif, la LED répétiteur s'illumine sinon elle s'éteint.
 
   MENU OPTIONS :    L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
   --------------    La rotation du codeur recircule les valeurs en cours de modification.    
                     B.P. n°1 : Incréments/Décréments de 1.
                     B.P. n°2 : Forcer les valeurs à la moitié de la plage possible.
                     B.P. n°3 : Incréments/Décréments de 10.
                     B.P. n°4 : Change d'Item vers le haut.
                     B.P. n°5 : Change d'Item vers le bas.
                     Codeur rotatif : Change la valeur de l'item indexé dans le menu.
                     B.P. central du codeur incrémental : Retour au MENU de BASE.

   MENU SYSTEME :    L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
   --------------    Le clavier est ignoré dans le Menu SYSTEME.
                     La rotation du codeur recircule l'index sur les trois items du menu.    
                     B.P. central du codeur incrémental : Active l'item indexé dans le menue.
                                                          Retour au MENU de BASE si Item en cours.
                     
 Branchements à effectuer : Aucun ajout ou changement.
 --------------------------
 Multiplexeur  S0 : Branchement de la LED verte du CLAVIER.
 Multiplexeur  S3 : Branchement de la LED bleue du mode VEILLE sur les moteurs.
 Multiplexeur S12 : Branchement d'une LED rouge pour visualiser en "répétiteur" le pourcentage LASER.
 Multiplexeur S15 : Sortie de pilotage PWM LASER.
                                                                PGM                 RAM dynamique
Programme de base initial sans aucun menu.                18962 Octets (61%)       792 Octets (38%)
Mise en place du menu de base et des quelque procédures : 19470 Octets (63%) +2%   794 Octets (38%)  +2% 
Mise en place du menu PYROGRAVER :                        20066 Octets (65%) +2%   806 Octets (39%)  +4%
Mise en place du menu FICHIER :                           20268 Octets (65%)       806 Octets (39%)
Mise en place du menu MANUEL :                            21286 Octets (69%) +4%   806 Octets (39%)  +8%
Mise en place du menu OPTIONS sans les rubans gradués :   21916 Octets (71%) +2%   818 Octets (39%) +10%
Mise en place des rubans gradués pour les OPTIONS :       22846 Octets (74%) +3%   819 Octets (39%) +13%
Menu SYSTEME en place :                                   22846 Octets (77%) +3%   821 Octets (40%) +16%  */

//--------------------- Déclarations pour le matériel -----------------------
#include <Wire.h> // Gère les protocole I2C sur A4 et A5 pour le Multiplexeur.
#include <EEPROM.h>
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)
#include "PetitFS.h"
FATFS fs;     // Zone de travail pour le volume SD : Objet système.
#include <Adafruit_PWMServoDriver.h> // déclaration du Multiplexeur.
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();

//------------- Définition des broches d'entrées analogiques ----------------
#define Ligne_trois_touches 14 // A0 pour lire le clavier à 3 BP. 
#define Ligne_deux_touches 15 // A1 pour lire le clavier à 2 BP. 
#define BP_central 16 // A2 pour lire le bouton central.
#define Pilotage_capteurs_Origines 17 // A3 active les modules uniquement aux moments pertinents.
#define Capteur_Origine_X  20 // A6 pour lire le capteur sur butée X.
#define Capteur_Origine_Y  21 // A7 pour lire le capteur sur butée X.
//-------------- Définition des broches de sorties Binaires -----------------
#define Codeur_B 2
#define Codeur_A 3
#define BUZZER 4
#define Moteurs_actifs 5 // Broche qui à l'état haut fait passer le moteur en mode "non alimenté".
#define Sens_sur_X 6 // Pilotage du sens de rotation sur X.
#define Un_pas_sur_X 7 // Pilotage "Faire un pas" sur X.
#define Sens_sur_Y 8 // Pilotage du sens de rotation sur Y.
#define Un_pas_sur_Y 9 // Pilotage "Faire un pas" sur Y.
#define chipSelect 10
//------------------- Déclaration des constante du programme ----------------
#define Seuil_Origine_X 900 // Tension moyenne entre Actif et neutre sur X.
#define Seuil_Origine_Y 553 // Tension moyenne entre Actif et neutre sur Y.
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.
#define Taille_tampon 30 // Taille des tampons pour les chaînes de caractères.
//----------------------- Déclaration des variables -------------------------
boolean Afficher_en_gravant; // Sera une option éventuelle pour le programme d'exploitation.
boolean BP_central_a_traiter;
boolean Demande_FIN_active; // Bascule pour ne pas avoir un doublon si fin demandée lors d'un PAS moteur.
boolean DX_Positif, DY_Positif; //, DX_sup_a_DY;
boolean Ecran_Noir;
boolean Fin_demandee;
boolean LASER_actif;
boolean Lecteur_OK;
boolean Ligne_G90_trouvee;
boolean Ligne_M3_trouvee;
boolean Mode_pas_a_pas;
boolean Mode_Verification_Programme;
boolean Mouvements_Rapide; // Ne pas ralentir les moteurs pour capter les origines.
boolean OrigineX_effective, OrigineY_effective;
boolean Saisie_Informations_Fichier;
boolean STOP; // Permet de sortir d'une gravure si fin demandée.
boolean Test_Capteurs_OK;

boolean Existe[10];

char Indice[10] = {'0','1','2','3','4','5','6','7','8','9'};
char Nom_Fichier[9] = "IMGN.GCO";
char Tampon[Taille_tampon];
char Titre[Taille_tampon];
String Contenu_ligne[Taille_tampon];

boolean A_set, B_set;   // État des sorties déphasées du codeur.
boolean INT_active;     // Indique un INT_active d'état détecté.
boolean Sens_positif; // Sens de rotation.
volatile boolean Rotation;  // Indique une activation du codeur rotatif.

byte Code_instruction; // Code en sortie de l'analyse syntaxique.
byte Curseur; // Définit la ligne de texte écran où doit se trouver le curseur.
byte Longueur_ligne_de_code;
byte Menu_en_cours; // Page-écran à rétablir suite à "Ecran NOIR".
byte Num_BP; // Désigne le bouton poussoir activé sur le clavier.
byte Num_Img_indexee;
byte Pourcentage; // Consigne de Pourcentage de puissance du LASER.
byte Puissance_MAX_sur_le_LASER; // Puissance qui sera appliquée quand Pourcentage = 100;
byte SAV_Num_BP; // Mémorisation de Num_BP sur la ligne 3BP pour le "test système".
byte SAV_Pourcentage;
byte Type_Erreur;

int Ancien_X, Ancien_Y; // Positions exprimées en dixièmes de mm.
int Delai_par_pas_elementaire;
int Pulse; // Rapport cyclique du signal de pilotage du LASER.


int U_sur_X, U_sur_Y; // Tensions sur les capteurs d'origine machine.

unsigned long Num_Ligne, Taille;

float Position_X, Position_Y, Origine_Image_X, Origine_Image_Y, Avance_par_pas;
//======================================================================================

void setup() {
  //---------------------- Définition des vecteurs d'interruption ----------------------
  attachInterrupt(0, Front_sur_A, CHANGE); // Appel à Front_sur_A si INT_active d'état détecté.
  // Broche de l'interruption 1 (E/S D3) :
  attachInterrupt(1, Front_sur_B, CHANGE); // Appel à Front_sur_B si INT_active d'état détecté.
  u8g.setFont(u8g_font_profont12); // Police de matrices de 6x10 pixels lettres MAJ/min comprises.
  pwm.begin(); // Initialise le module multiplexeur.
  pwm.setPWMFreq(1000); // Fréquence particulière 1000Hz pour piloter le module LASER.
  pinMode(Codeur_A,INPUT); pinMode(Codeur_B,INPUT);
  pinMode(chipSelect, OUTPUT); digitalWrite(chipSelect,HIGH);
  pinMode(BUZZER, OUTPUT); digitalWrite(BUZZER, LOW);
  pinMode(Pilotage_capteurs_Origines,OUTPUT); digitalWrite(Pilotage_capteurs_Origines, LOW);
  pinMode(Moteurs_actifs, OUTPUT); 
  pinMode(Sens_sur_X, OUTPUT); pinMode(Un_pas_sur_X, OUTPUT); digitalWrite(Un_pas_sur_X, LOW);
  pinMode(Sens_sur_Y, OUTPUT); pinMode(Un_pas_sur_Y, OUTPUT); digitalWrite(Un_pas_sur_Y, LOW);
  Eteindre_les_deux_LED_LASER(); // Spécifique à ce démonstrateur.
  pinMode(11,INPUT); pinMode(12,INPUT); pinMode(13,INPUT);
  BP_central_a_traiter = false; digitalWrite(BP_central, HIGH); // Valide R PUL-UP sur A2.
  Front_sur_A(); Front_sur_B(); // Routines d'IRQ pour le codeur rotatif.
  Mode_pas_a_pas = false; Mode_Verification_Programme = false; Ecran_Noir = false; Num_BP = 0;
  Delai_par_pas_elementaire = 10; Afficher_en_gravant = false;
  Num_Img_indexee = 0; Eteindre_LED_clavier(); Saisie_Informations_Fichier = false;
  Bilan_contenu_SD(); Curseur = 5; Ancien_X = 0; Ancien_Y = 0;} // Machine supposée ici sur origine.
 
void loop() { // Dans la boucle de base le clavier ne gère que l'économiseur d'écran.
  MENU_de_base(); // L'écran est rafraichi en permanence mais ce n'est pas pénalisant.
  //--------------------------------- Traite le B.P. central ---------------------------
  Teste_activation_BP_codeur_incremental(); // Si B.P. activé saisir les caractéristiques de l'image.
  if (BP_central_a_traiter) { // Vectorisation par le MENU de BASE.
      BP_central_a_traiter = false;
      switch(Curseur) {Curseur = 1; 
        case 1 : {Menu_en_cours = 1; Menu_PYROGRAVER(); break;}
        case 2 : {Menu_en_cours = 2 ; Menu_FICHIER(); break;}
        case 3 : {Menu_Mode_MANUEL(); break;}
        case 4 : {Menu_OPTIONS(); break;}
        case 5 : Menu_SYSTEME();}}
  //--------------------- Traite la rotation du codeur incrémental ---------------------
  if (Rotation) TRAITE_LA_ROTATION_DU_CODEUR_INCREMENTAL();
  //---------------------- Traiter la requête de l'un des cinq B.P. --------------------
  Tester_le_Clavier(); if (Num_BP !=0) {ATTENDRE_le_relacher(); Seul_BP_NOIR_valide();}}

void Tester_les_capteurs_Origine() {BIP(); Fin_demandee = true;}

void Allume_LED_clavier() {pwm.setPWM(0, 0, 4095);}
void Eteindre_LED_clavier() {pwm.setPWM(0, 0, 0);}
     
//------------------------------ Différents écrans affichés sur OLED -------------------------------
void Aff_TEXTE_EEPROM(int PTR, byte Longueur) {// Routines pour les affichages textes EEPROM.
    for (byte I=0; I<Longueur; I++) {u8g.print(char(EEPROM.read(PTR))); PTR++;}; }

void Aff_Item_demi_seconde(int PTR, byte LGR) {
  u8g.firstPage(); do {u8g.setPrintPos(0, 30); Aff_TEXTE_EEPROM(PTR, LGR);
  if (Num_BP == 3) Affiche_Deux_points_espace_OUI_NON(Afficher_en_gravant);
  if (Num_BP == 73) Affiche_Deux_points_espace_OUI_NON(Mode_pas_a_pas);} // La valeur 73 pour le B.P.
     // est choisie arbitrarement pour différencier "Afficher_en_gravant" et "Mode_pas_a_pas".
  while(u8g.nextPage()); delay (500); Eteindre_Ecran();}

void Eteindre_Ecran(){u8g.firstPage(); do {} while(u8g.nextPage());}
 
void Liste_contenu_SD() {// Ne teste plus la présence carte et liste son "contenu images" en aveugle
  byte X,Y;              // en utilisant le tableau de booléens Existe[10] initialisé sur RESET.
  // Afficher la liste de l'état des fichiers sur OLED et positionne l'index sur le fichier pointé :
  u8g.firstPage(); do {
     Y = 10; X = 0;
     for (byte I=0; I<10; I++) {
          if (I > 4) X = 66; if (I == 5) Y = 10;
          Debut_Nom(X,Y,I); if (Existe[I]) Affiche_OUI(); else Affiche_NON();  Y = Y + 13;
          if (I == Num_Img_indexee) Aff_TEXTE_EEPROM(50,2);}} 
  while(u8g.nextPage());}

void AFFICHE_etat_machine(){
  if (!Ecran_Noir) {
      u8g.firstPage(); do {
      u8g.setPrintPos(0, 12); u8g.print(Titre);
      u8g.setPrintPos(0, 24); Aff_TEXTE_EEPROM(45,6); u8g.print(Num_Ligne);
      u8g.setPrintPos(0, 37); for(byte I=0; I<Taille_tampon; I++) u8g.print(Contenu_ligne[I]);
      u8g.setPrintPos(0, 50); Aff_TEXTE_EEPROM(52,4); u8g.print(Pourcentage); Aff_TEXTE_EEPROM(326,10);
      u8g.setPrintPos(0, 63); Aff_TEXTE_EEPROM(56,4); u8g.print(Position_X,1);
      u8g.setPrintPos(65, 663); Aff_TEXTE_EEPROM(60,4); u8g.print(Position_Y,1);}
      while(u8g.nextPage());}
  Menu_en_cours = 7;
  if ((Mode_pas_a_pas) && (!Ecran_Noir)) {
       ATTENDRE_un_BP(); if (Num_BP == 2) Inverser_bascule_Ecran_Noir();}
  Tester_le_Clavier(); if (Num_BP == 2) Inverser_bascule_Ecran_Noir();}

void Liste_contenu_Fichier() {
 u8g.firstPage(); do {
 u8g.setPrintPos(0, 12); u8g.print(Titre);
 u8g.setPrintPos(0, 24); Aff_TEXTE_EEPROM(415,7); u8g.print(Taille); Aff_TEXTE_EEPROM(421,7);
 u8g.setPrintPos(0, 36); Aff_TEXTE_EEPROM(186,12); u8g.print(Origine_Image_X); 
 u8g.setPrintPos(0, 48); Aff_TEXTE_EEPROM(200,12); u8g.print(Origine_Image_Y);  
 u8g.setPrintPos(0, 60); Aff_TEXTE_EEPROM(428,12); u8g.print(Taille / 1800); Aff_TEXTE_EEPROM(439,4);}
while(u8g.nextPage());}

void Affiche_Deux_points_espace_OUI_NON(boolean OUI) {
  if (OUI) Aff_TEXTE_EEPROM(173,5); else Aff_TEXTE_EEPROM(179,5);}

//-------------------- Routines de servitude pour traiter le capteur incrémental -------------------
void Delay_antirebonds() {for(int T=0; T<1000; T++);} // Valeur de 100 expérimentale.
  
void Front_sur_A(){ // Interruption quand A change d'état avant B.
  if (INT_active) Delay_antirebonds(); // Attendre un peu la fin des rebonds.
  if (digitalRead(Codeur_A) != A_set) {// Test pour savoir si l'état a changé.
      A_set = !A_set;
      if (A_set && !B_set) {Sens_positif = true; Rotation = true; Delay_antirebonds();}}}
  
void Front_sur_B(){ // Interruption quand B change d'état avant A.
  if (INT_active) Delay_antirebonds(); // Attendre un peu la fin des rebonds. 
  if (digitalRead(Codeur_B) != B_set) {// Test pour savoir si l'état a changé.
      B_set = !B_set;
      // Décrémenter le compteur si B avant A.
      if (B_set && !A_set) {Sens_positif = false; Rotation = true; Delay_antirebonds();}}}
//-------------------------------------------------------------------------------------------------
void Delay_1mS() {delay(1);}
void Delay_30mS() {delay(30);}
void Delay_100mS() {delay(100);}

void BIP() {digitalWrite(BUZZER, HIGH); Delay_100mS(); digitalWrite(BUZZER, LOW);}

void Tester_le_Clavier() {// Les valeurs tiennent compte de VCC = 4V car fourni par la carte NANO.
  Num_BP = 0; // Signale aucun B.P. utilisé.
  U_sur_X = analogRead(Ligne_trois_touches);
  if (U_sur_X < 758) {Num_BP = 1;
      if (U_sur_X < 508)  Num_BP = 2; if (U_sur_X < 230)  Num_BP = 3;}
  SAV_Num_BP = Num_BP; 
  U_sur_Y = analogRead(Ligne_deux_touches);
  if (U_sur_Y < 709) {Num_BP = 5; if (U_sur_Y < 300)  Num_BP = 4;}}

void ATTENDRE_le_relacher() {
  byte SAV_Num_BP = Num_BP;
  byte COMPTEUR = 0; Delay_30mS(); // Attendre_la_stabilisation du travail.
  Allume_LED_clavier();
  while (COMPTEUR < NB_tests_antirebonds) {// Attendre_la_stabilisation du repos :
         COMPTEUR++; Tester_le_Clavier(); if (Num_BP > 0) COMPTEUR = 0;}
  Eteindre_LED_clavier(); Num_BP = SAV_Num_BP;}

void ATTENDRE_un_BP() {
  boolean Allumer;
  Num_BP = 0;
  while (Num_BP == 0) {Tester_le_Clavier(); Delay_100mS();
         Allumer =!Allumer; if (Allumer) Allume_LED_clavier(); else Eteindre_LED_clavier();}
  ATTENDRE_le_relacher();}

void Retablir_Ecran_OLED() {
    switch (Menu_en_cours) {
    case 1 : {MENU_de_base(); break;}
    case 2 : {Liste_contenu_SD(); break;}
    case 6 : {Liste_contenu_SD(); break;}
    case 7 : {AFFICHE_etat_machine(); break;}}}

void Inverser_bascule_Ecran_Noir() {// Bascule pour éteindre ou activer l'écran OLED.
  if (Num_BP == 2) {Ecran_Noir = !Ecran_Noir; ATTENDRE_le_relacher();
      if (Ecran_Noir) Eteindre_Ecran(); else Retablir_Ecran_OLED();}}

void Affiche_ERR_et_attente_BP(int PTR, byte LGR) {
  u8g.firstPage(); do {u8g.setPrintPos(5, 35); Aff_TEXTE_EEPROM(PTR,LGR);} while(u8g.nextPage());
  BIP(); ATTENDRE_un_BP();}

void Debut_Nom(byte X, byte Y, byte N) {u8g.setPrintPos(X, Y); Aff_TEXTE_EEPROM(0,3); u8g.print(N);}
void Affiche_OUI() {Aff_TEXTE_EEPROM(3,4);}
void Affiche_NON() {Aff_TEXTE_EEPROM(7,4);}

void Probleme_de_lecture() {// Impose de faire un RESET.
  INFINI: 
  if (Type_Erreur == 4) Affiche_ERR_et_attente_BP(11,21); // Affiche "Pb sur le lecteur SD."
  else if (Type_Erreur == 5) Affiche_ERR_et_attente_BP(267,19); // Affiche "Pb Capteur ORIGINE !"
       else Affiche_ERR_et_attente_BP(113,17); // Affiche "Erreur en lecture"
  u8g.firstPage(); // Affiche "Resoudre le probleme puis RESET !"
  do {u8g.setPrintPos(0, 22); Aff_TEXTE_EEPROM(212,20);
      u8g.setPrintPos(15, 42); Aff_TEXTE_EEPROM(232,16);}
       while(u8g.nextPage());
  ATTENDRE_un_BP(); goto INFINI;}

void Bilan_contenu_SD() { // Teste la présence carte et message d'erreur sur boucle infinie si non OK :
  Lecteur_OK = true; if (pf_mount(&fs)) Lecteur_OK = false; 
  if (!Lecteur_OK) // Teste la présence carte et message d'erreur sur boucle infinie si non OK :
     {Type_Erreur = 4; Probleme_de_lecture();}
  else // Construire la table de présence des dix fichiers possibles :
     for (byte I=0; I<10; I++) {Nom_Fichier[3] = Indice[I]; Existe[I] = !pf_open(Nom_Fichier);}}

void Mesurer_U_Capteur(boolean Sur_X) {
  #define Nb_Iterations 20 // Mesure avec Nb itérations pour l'intégration "d'antiparasitage".
  // La valeur de 20 est choisie expérimentalement et semble un bon compromis entre des
  // mesures fiables et une rapidité suffisante de rotation des moteurs.
  long Valeurs_lues;
  byte Compteur = Nb_Iterations;
  Valeurs_lues = 0;
  for (int I = 0; I < Nb_Iterations; I++) // Cumuler N mesures. 
      {if (Sur_X) Valeurs_lues = Valeurs_lues + analogRead(Capteur_Origine_X);
       else Valeurs_lues = Valeurs_lues + analogRead(Capteur_Origine_Y);}
  if (Sur_X) U_sur_X = int(Valeurs_lues / Nb_Iterations); else U_sur_Y = int(Valeurs_lues / Nb_Iterations);}
  
void Traiter_Origines_sans_allumer() {
  Mesurer_U_Capteur(true); // Donc mesure avec anti-rebonds sur le capteur X.
  Mesurer_U_Capteur(false); // Donc mesure avec anti-rebonds sur le capteur Y.
  OrigineX_effective = (U_sur_X > Seuil_Origine_X); OrigineY_effective = (U_sur_Y > Seuil_Origine_Y); 
  digitalWrite(Pilotage_capteurs_Origines, LOW);}

void Mesurer_U_sur_capteurs_Origines() {
  digitalWrite(Pilotage_capteurs_Origines, HIGH); Delay_1mS(); Traiter_Origines_sans_allumer();}

void Ouvrir_le_fichier() { // Si erreur détectée en ouverture : Impose un RESET.
  Nom_Fichier[3] = Indice[Num_Img_indexee]; // Construire le Nom du Fichier indexé.
  if (pf_open(Nom_Fichier)) Probleme_de_lecture();} // C'est Probleme_de_lecture() qui impose un RESET.

void Positionne_le_curseur(){
  byte Y;
  switch (Curseur) {
    case 1 : {Y = 12; break;}
    case 2 : {Y = 24; break;}
    case 3 : {Y = 36; break;}
    case 4 : {Y = 48; break;}
    case 5 : Y = 60;}
    u8g.setPrintPos(0, Y); u8g.print('>');}

void MENU_de_base(){
  Menu_en_cours = 0;
  if (!Ecran_Noir) {
      u8g.firstPage(); do {
      u8g.setPrintPos(14, 12); Aff_TEXTE_EEPROM(149,10);
      u8g.setPrintPos(14, 24); Aff_TEXTE_EEPROM(379,7);
      u8g.setPrintPos(14, 36); Aff_TEXTE_EEPROM(386,11); 
      u8g.setPrintPos(14, 48); Aff_TEXTE_EEPROM(443,7);  
      u8g.setPrintPos(14, 60); Aff_TEXTE_EEPROM(450,7);
      Positionne_le_curseur();}
      while(u8g.nextPage());}}
 
void TRAITE_LA_ROTATION_DU_CODEUR_INCREMENTAL() {
  byte Mini, Maxi;
  INT_active = true; // Armer un nouveau comptage.
  Rotation = false; // Prise en compte du traitement.
  //-------------------- Ajuster la valeur du curseur -------------------
  if ((Menu_en_cours == 1) || (Menu_en_cours == 2)) {// Indexer l'un des 10 fichiers.
     if (Sens_positif) {Num_Img_indexee++; if (Num_Img_indexee == 10) Num_Img_indexee = 0;}
     else {if (Num_Img_indexee > 0) Num_Img_indexee--; else Num_Img_indexee = 9;}}
  else {switch (Menu_en_cours) {// Indexer dans les lignes du menu en cours.
        case 1 : {Mini = 1; Maxi = 5; break;}}
        if (Sens_positif) {Curseur++; if (Curseur == (Maxi + 1)) Curseur = Mini;}
        else {if (Curseur > 1) Curseur--; else Curseur = Maxi;}}
  //-------------- Rafraichir la page-écran et son curseur --------------
  switch (Menu_en_cours) {// Le menu de base est traité dans la boucle principale.
    case 1 : {Liste_contenu_SD(); break;}      // Liste le contenu SD et positionne le curseur sur
    case 2 : {Liste_contenu_SD(); break;}}}    // le fichier pointé par Num_Img_indexee

void Eteindre_les_deux_LED_LASER() {pwm.setPWM(12, 0, 0); pwm.setPWM(15, 0, 0);}

void Seul_BP_NOIR_valide() {
  if (Num_BP == 2) {Inverser_bascule_Ecran_Noir(); if (!Ecran_Noir) Retablir_Ecran_OLED();}
  else BIP();}

void Teste_activation_BP_codeur_incremental() {
  if (analogRead(BP_central) < 512) {// Si le B.P. central est activé :
     // ========== Attendre le relacher du B.P. central. ==========
     Allume_LED_clavier();
     while (analogRead(BP_central) < 512); // Boucler sans rien faire pour attendre le relâché.
     Eteindre_LED_clavier();
     // ===========================================================
     BP_central_a_traiter = true;}}

void Teste_SORTIR_du_MENU() {
  Teste_activation_BP_codeur_incremental(); // Si B.P. activé saisir les caractéristiques de l'image.
  if (BP_central_a_traiter) {Fin_demandee = true; BP_central_a_traiter = false;}}
  
void PYROGRAVER() {// Procédure épurée : Uniquement pour tester les menus.
  if (Existe[Num_Img_indexee]) {// Il ne faut capturer l'origine que si le fichier s'ouvre.
      Eteindre_Ecran(); Ecran_Noir = true; Num_BP = 0;} BIP(); Liste_contenu_SD();}

void VERIFIER_LE_FICHIER() {// Procédure épurée : Uniquement pour tester les menus.
  if (Existe[Num_Img_indexee]) {// Il ne faut capturer l'origine que si le fichier s'ouvre.
      BIP(); Liste_contenu_SD();}}

void Positionner_LASER_sur_Origine_Image(boolean Centrage_sur_le_plateau) {Aff_Item_demi_seconde(248, 19);}

void Espace_deuxpoints_Espace() {Aff_TEXTE_EEPROM(412,3);}

void Menu_PYROGRAVER() {
  Ecran_Noir = false; Fin_demandee = false;
  Num_Img_indexee = 0; Liste_contenu_SD();  // Le curseur est positionné sur le fichier Img0. 
  while (!Fin_demandee) {
    if (!Ecran_Noir) Liste_contenu_SD();
    Teste_SORTIR_du_MENU(); // Vérifie si le BP central est activé et si oui force Fin_demandee à true.
    if (Rotation) TRAITE_LA_ROTATION_DU_CODEUR_INCREMENTAL(); // Déplace l'index dans la liste des fichiers.
    Tester_le_Clavier();
    if (Num_BP !=0) {
        ATTENDRE_le_relacher();
        switch(Num_BP) {// Déplacer sur Origine image impose d'armer l'option en validant "Afficher_en_gravant".
          case 1 : {if (Afficher_en_gravant) {// Centre le LASER sur l'origine FICHIER.gco. si option "armée".
                        Positionner_LASER_sur_Origine_Image(false); Afficher_en_gravant = false;}
                    else {BIP(); Aff_Item_demi_seconde(604, 10);} break;}
          case 2 : {Inverser_bascule_Ecran_Noir(); break;}
          case 3 : {Afficher_en_gravant = !Afficher_en_gravant; Aff_Item_demi_seconde(102, 10); break;}
          case 4 : {Aff_Item_demi_seconde(149, 10); PYROGRAVER(); break;}
          case 5 : {Liste_contenu_Fichier(); ATTENDRE_un_BP(); Liste_contenu_SD();}}
        Num_BP = 0;}}} // Action sur le B.P. prise en compte.  

void Menu_FICHIER() {
  Ecran_Noir = false; Fin_demandee = false;
  Num_Img_indexee = 0; Liste_contenu_SD();  // Le curseur est positionné sur le fichier Img0. 
  while (!Fin_demandee) {
    if (!Ecran_Noir) Liste_contenu_SD();
    Teste_SORTIR_du_MENU(); // Vérifie si le BP central est activé et si oui force Fin_demandee à true.
    if (Rotation) TRAITE_LA_ROTATION_DU_CODEUR_INCREMENTAL(); // Déplace l'index dans la liste des fichiers.
    Tester_le_Clavier();
    if (Num_BP !=0) {
        ATTENDRE_le_relacher();
        switch(Num_BP) {// Déplacer sur Origine image impose d'armer l'option en validant "Afficher_en_gravant".
          case 1 : {Num_Img_indexee = 0; Bilan_contenu_SD(); break;} // Relecture de la carte SD.
          case 2 : {Inverser_bascule_Ecran_Noir(); break;}
          case 3 : {Mode_pas_a_pas = !Mode_pas_a_pas; Num_BP = 73; Aff_Item_demi_seconde(398, 15); break;}
          case 4 : {Aff_Item_demi_seconde(368, 18); VERIFIER_LE_FICHIER(); break;}
          case 5 : {Liste_contenu_Fichier(); ATTENDRE_un_BP(); Liste_contenu_SD();}}
        Num_BP = 0;}}} // Action sur le B.P. prise en compte.  

void Menu_Mode_MANUEL() { // L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
  // Les déplacements sont simulés et sans tests sur les limites.
  // >>>>>>>>>>>>>>> La gestion du laser N'Allumer que durant les déplacements n'est pas gérée.
  // >>>>>>>>>>>>>>> Dans le programme d'exploitation en mode manuel c'est la puissance maximale
  //                 définie dans les OPTIONS qui sera appliquée au LASER.
  Fin_demandee = false; LASER_actif = false; STOP = false; Mouvements_Rapide = true; Avance_par_pas = 0.5;
  while (!Fin_demandee) {
    Ecran_mode_MANUEL(); // En mode manuel l'économiseur d'écran n'est pas pertinent.
    Teste_SORTIR_du_MENU(); // Vérifie si le BP central est activé et si oui force Fin_demandee à true.
    //------------------------ Traiter la rotation du codeur incrémental ------------------------
    if (Rotation) {
        Rotation = false; // Prise en compte du traitement.
        if (Sens_positif) {Avance_par_pas = Avance_par_pas + 0.5;
                           if (Avance_par_pas == 10.5) Avance_par_pas = 0.5;}
        else {if (Avance_par_pas > 0.5) Avance_par_pas = Avance_par_pas - 0.5; else Avance_par_pas = 10;}}  
    //-------------------------------------------------------------------------------------------
    Tester_le_Clavier();
    if (Num_BP !=0) {
        switch(Num_BP) {
          case 1 : {Position_X = (Position_X) - Avance_par_pas; break;}
          case 2 : {ATTENDRE_le_relacher();
                    LASER_actif = !LASER_actif; Mouvements_Rapide = !LASER_actif; break;}
          case 3 : {Position_X = (Position_X) + Avance_par_pas; break;}
          case 4 : {Position_Y = (Position_Y) + Avance_par_pas; break;}
          case 5 : {Position_Y = (Position_Y) - Avance_par_pas; break;}}
        Num_BP = 0;}}} // Action sur le B.P. prise en compte.  

void AFF_s() {u8g.print('s');}

void Ecran_mode_MANUEL(){
  Menu_en_cours = 3; Pourcentage = 73; // Valeur arbitraire pour tester la procédure.
  u8g.firstPage(); do {
  u8g.setPrintPos(0, 12); Aff_TEXTE_EEPROM(286,10); Espace_deuxpoints_Espace(); u8g.print(Position_X,1);
  u8g.setPrintPos(0, 24); Aff_TEXTE_EEPROM(614,10); Espace_deuxpoints_Espace(); u8g.print(Position_Y,1);
  u8g.setPrintPos(0, 36); Aff_TEXTE_EEPROM(667,11); Espace_deuxpoints_Espace(); u8g.print(Avance_par_pas,1);
  u8g.setPrintPos(0, 48); Aff_TEXTE_EEPROM(471,11); Espace_deuxpoints_Espace();
  u8g.print(float(Delai_par_pas_elementaire) / 1000,2); AFF_s();
  u8g.setPrintPos(0, 60); Aff_TEXTE_EEPROM(482,5); Espace_deuxpoints_Espace();
  if (LASER_actif) {u8g.print(Pourcentage); Aff_TEXTE_EEPROM(487,9); pwm.setPWM(12, 0, 4050);}
  else {Aff_TEXTE_EEPROM(181,3); pwm.setPWM(12, 0, 0);}}
  while(u8g.nextPage());}

void Menu_OPTIONS() { // L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
  // La valeur 73 de Puissance_MAX_sur_le_LASER est arbitraire pour tester la procédure.
  byte Increment, Increment_Delai;
  Fin_demandee = false; Curseur = 2; Puissance_MAX_sur_le_LASER = 73;  Increment = 1; Increment_Delai = 10;
  while (!Fin_demandee) {
    Liste_les_OPTIONS();
    Teste_SORTIR_du_MENU(); // Vérifie si le BP central est activé et si oui force Fin_demandee à true.
    //------------------------ Traiter la rotation du codeur incrémental ------------------------
    if (Rotation) {
        Rotation = false; // Prise en compte du traitement.
        switch(Curseur) {
          case 2 : {if (Sens_positif) {Puissance_MAX_sur_le_LASER = Puissance_MAX_sur_le_LASER + Increment;
                                      if (Puissance_MAX_sur_le_LASER > 100) Puissance_MAX_sur_le_LASER = 1;}
                    else {Puissance_MAX_sur_le_LASER = Puissance_MAX_sur_le_LASER - Increment;
                          if (Puissance_MAX_sur_le_LASER > 200) Puissance_MAX_sur_le_LASER = 100;} break;}
          case 3 : {Afficher_en_gravant = !Afficher_en_gravant; break;}
          case 4 : {if (Sens_positif) {
                        Delai_par_pas_elementaire = Delai_par_pas_elementaire + Increment_Delai;
                        if (Delai_par_pas_elementaire > 9000) Delai_par_pas_elementaire = 10;}
                    else {Delai_par_pas_elementaire = Delai_par_pas_elementaire - Increment_Delai;
                          if (Delai_par_pas_elementaire < 10) Delai_par_pas_elementaire = 9990;}}}}  
    //-------------------------------------------------------------------------------------------
    Tester_le_Clavier();
    if (Num_BP !=0) {
        ATTENDRE_le_relacher();
        switch(Num_BP) {// Déplacer sur Origine image impose d'armer l'option en validant "Afficher_en_gravant".
          case 1 : {Increment = 1; Increment_Delai = 10; break;}
          case 2 : {Puissance_MAX_sur_le_LASER = 50; Delai_par_pas_elementaire = 5000; break;}
          case 3 : {Increment = 10; Increment_Delai = 100; break;}
          case 4 : {if (Curseur > 2) Curseur--; else Curseur = 4; break;}
          case 5 : {Curseur++; if (Curseur == 5) Curseur = 2;}
        Num_BP = 0;}}} // Action sur le B.P. prise en compte. 
    Curseur = 4;}

void AFF_zero() {u8g.print('0');}

void Trace_les_rubans() {// Placé en subroutine pour faciliter la lisibilité de Liste_les_OPTIONS().
  byte LGR_ruban;
  boolean Plage_une_seconde = (Delai_par_pas_elementaire < 1001);
  // Echelle graduée du haut :
  u8g.setPrintPos(0, 10); AFF_zero(); u8g.setPrintPos(111, 10); Aff_TEXTE_EEPROM(332,3);
  u8g.drawFrame(7,8,101,5);
  for (byte X=7; X<110; X=X+20) u8g.drawVLine(X,0,8);  // Tracer les grandes graduations.
  for (byte X=17; X<100; X=X+20) u8g.drawVLine(X,4,4); // Tracer les petites graduations.
  u8g.drawBox(8,9,Puissance_MAX_sur_le_LASER,3);
  // Echelle graduée du bas :
  u8g.setPrintPos(0, 61); AFF_zero(); u8g.setPrintPos(111, 61);
  if (Plage_une_seconde) Aff_TEXTE_EEPROM(98,2); else Aff_TEXTE_EEPROM(684,3); u8g.drawFrame(7,59,101,5);
  for (byte X=7; X<120; X=X+20) u8g.drawVLine(X,51,8);  // Tracer les grandes graduations.
  for (byte X=17; X<110; X=X+20) u8g.drawVLine(X,55,4); // Tracer les petites graduations.
  if (Plage_une_seconde) LGR_ruban = byte(Delai_par_pas_elementaire / 10);
  else LGR_ruban = byte(Delai_par_pas_elementaire / 100);
  u8g.drawBox(8,60,LGR_ruban,3);} // Tracé du ruban.

void Liste_les_OPTIONS() { // L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
  u8g.firstPage(); do {
  u8g.setPrintPos(14, 24); Aff_TEXTE_EEPROM(482,6); u8g.print(Puissance_MAX_sur_le_LASER);
  Aff_TEXTE_EEPROM(678,6); u8g.setPrintPos(14, 36); Aff_TEXTE_EEPROM(496,13);
  Affiche_Deux_points_espace_OUI_NON(Afficher_en_gravant); u8g.setPrintPos(14, 48); Aff_TEXTE_EEPROM(471,5);
  Espace_deuxpoints_Espace(); u8g.print(float(Delai_par_pas_elementaire) / 1000,2); AFF_s();
  Trace_les_rubans(); Positionne_le_curseur();}
  while(u8g.nextPage());}

void Menu_SYSTEME() { // L'économiseur d'écran n'est pas effectif pour cette option car peu utile.
  Fin_demandee = false; Curseur = 2;
  while (!Fin_demandee) {
    Affiche_les_OPTIONS_SYTEME();
    //------------------------ Traiter le B.P. central du codeur rotatif ------------------------
    Teste_activation_BP_codeur_incremental();
    if (BP_central_a_traiter) {
        BP_central_a_traiter = false;
        switch(Curseur) {
          case 2 : {BIP(); Tester_les_capteurs_Origine(); break;}
          case 3 : {Mesurer_sur_les_capteurs_origine(); break;}
          case 4 : {Mesurer_sur_les_BP_CLAVIER(); break;}}}
    //------------------------ Traiter la rotation du codeur incrémental ------------------------
    if (Rotation) {
        Rotation = false; // Prise en compte du traitement.
       if (Sens_positif) {Curseur++; if (Curseur == 5) Curseur = 2;}
       else {if (Curseur > 2) Curseur--; else Curseur = 4;}}}
    //-------------------------------------------------------------------------------------------
  Curseur = 5;}

void Affiche_les_OPTIONS_SYTEME() { // L'économiseur d'écran n'est pas utile pour cette option.
  u8g.firstPage(); do {
  u8g.setPrintPos(0, 12); Aff_TEXTE_EEPROM(1004,20); u8g.setPrintPos(14, 24); Aff_TEXTE_EEPROM(570,17);
  u8g.setPrintPos(14, 36); Aff_TEXTE_EEPROM(587,17); u8g.setPrintPos(14, 48); Aff_TEXTE_EEPROM(687,18);
  Positionne_le_curseur();} while(u8g.nextPage());}

void Mesurer_sur_les_capteurs_origine() {// Clavier et codeur rotatifs ignorés.
  while (!Fin_demandee) {
    Teste_SORTIR_du_MENU();
    Mesurer_U_sur_capteurs_Origines();
    u8g.firstPage(); do {
    u8g.setPrintPos(15, 15); Aff_TEXTE_EEPROM(184,14); u8g.print(U_sur_X);
    u8g.setPrintPos(15, 30); Aff_TEXTE_EEPROM(198,14); u8g.print(U_sur_Y);
    u8g.setPrintPos(15, 45); Aff_TEXTE_EEPROM(186,10);
    Affiche_Deux_points_espace_OUI_NON(OrigineX_effective);
    u8g.setPrintPos(15, 60); Aff_TEXTE_EEPROM(200,10); 
    Affiche_Deux_points_espace_OUI_NON(OrigineY_effective);}
  while(u8g.nextPage());}}

void Mesurer_sur_les_BP_CLAVIER() {// Clavier et codeur rotatifs ignorés.
  while (!Fin_demandee) {
    Teste_SORTIR_du_MENU();
    Tester_le_Clavier();
    u8g.firstPage(); do {
    u8g.setPrintPos(0, 15); Aff_TEXTE_EEPROM(624,17); u8g.print(U_sur_X);
    u8g.setPrintPos(0, 30); Aff_TEXTE_EEPROM(657,10); u8g.print(SAV_Num_BP);
    u8g.setPrintPos(0, 45); Aff_TEXTE_EEPROM(641,16); u8g.print(U_sur_Y);
    u8g.setPrintPos(0, 60); Aff_TEXTE_EEPROM(657,10); 
    if (SAV_Num_BP == 0) u8g.print(Num_BP); else AFF_zero();}
    while(u8g.nextPage());}}

